=== supplementary_scripts/amarok_live/CMakeLists.txt ===
install(PROGRAMS amarok_live.py README amarok.live.remaster.part1.sh amarok.live.remaster.part2.sh DESTINATION ${KDE_INSTALL_DATADIR}/amarok/scripts/amarok_live)
