=== tests/core-impl/CMakeLists.txt ===
add_subdirectory( collections )
add_subdirectory( meta )
add_subdirectory( playlists )
add_subdirectory( support )
