=== tests/core/CMakeLists.txt ===
add_subdirectory( capabilities )
add_subdirectory( collections )
add_subdirectory( interfaces )
add_subdirectory( logger )
add_subdirectory( meta )
add_subdirectory( playlists )
