=== debian/changelog ===
amarok (3.3.1-2) unstable; urgency=medium

  [ Pino Toscano ]
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Properly use the kf6 dh addon when calling dh_auto_configure (as amarok
    is based on Qt 6 / KF6), rather than kf5.
  * Add the libcrypt-dev build dependency, as a couple of plugins link to it.
    (Closes: #1107026)
  * Tweak the descriptions a bit. (Closes: #1111872)
  * Switch the libqt5sql5-mysql, libqt5sql5-psql, and libqt5sql5-sqlite suggests
    to their Qt 6 counterparts, i.e. libqt6sql6-mysql, libqt6sql6-psql, and
    libqt6sql6-sqlite.
  * Update amarok.install according to the newer kpackage, which does not
    generate appstream metainfo files for packages anymore.
  * Since Amarok 3.3 Phonon is no more used, so:
    - drop the libphonon4qt6-dev, and libphonon4qt6experimental-dev build
      dependencies
    - drop the "Phonon Backend" section in README.Debian
    - drop phonon4qt5-backend in debian/bug-control
    - drop amarok.bug-presubj, which is practically entirely about Phonon

  [ Boyuan Yang ]
  * Drop build-dep on transitional pkg libtag1-dev again.

 -- Pino Toscano <pino@debian.org>  Fri, 10 Oct 2025 09:29:44 +0200

amarok (3.3.1-1) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * New upstream release (3.3.1).
  * Build against Qt6, update build-deps and deps with the info from cmake.
  * Update the list of installed files.
  * Bump Standards-Version to 4.7.2, no change required.
  * Refresh patches.
  * Refresh lintian overrides.
  * Refresh copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 13 Aug 2025 19:53:16 +0200
